pub mod days;
#[macro_use]
extern crate scan_fmt;

use std::time::Instant;

fn main() {
    days::d15::solve()
    //_all_days()
}

fn _all_days() {
    let start = Instant::now();
    println!("\nDay 1");
    days::d01::solve();
    print_elapsed(&start);

    println!("\nDay 2");
    days::d02::solve();
    print_elapsed(&start);

    println!("\nDay 3");
    days::d03::solve();
    print_elapsed(&start);

    println!("\nDay 4");
    days::d04::solve();
    print_elapsed(&start);

    println!("\nDay 5");
    days::d05::solve();
    print_elapsed(&start);

    println!("\nDay 6");
    days::d06::solve();
    print_elapsed(&start);

    println!("\nDay 7");
    days::d07::solve();
    print_elapsed(&start);

    println!("\nDay 8");
    days::d08::solve();
    print_elapsed(&start);

    println!("\nDay 9");
    days::d09::solve();
    print_elapsed(&start);

    println!("\nDay 10");
    days::d10::solve();
    print_elapsed(&start);

    println!("\nDay 11");
    days::d11::solve();
    print_elapsed(&start);

    println!("\nDay 12");
    days::d12::solve();
    print_elapsed(&start);

    println!("\nDay 13");
    days::d13::solve();
    print_elapsed(&start);

    println!("\nDay 14");
    days::d14::solve();
    print_elapsed(&start);

    println!("\nDay 15");
    days::d15::solve();
    print_elapsed(&start);
}

fn print_elapsed(start: &Instant) {
    println!(
        " Elapsed: {}.{}ms",
        start.elapsed().as_millis(),
        start.elapsed().as_micros() % 1000
    )
}
